
if not exists(select 1 from view_gen_config where config='planearOTpreventivaConSP')
begin
	insert into gen_config
	(uid,eid,config,valor,descripcion,modulo)
	select uid,'01','planearOTpreventivaConSP','0'
		,'determina si al crear la ot desde el cronograma, la planeación se obtendrá desde el SP aju_planeaOTDesdeVisita'
		,'cnt'
	from seg_usuario 
	where id=1
end


if not exists (select 1 from sys.procedures where name='aju_planeaOTDesdeVisita')

exec ('create procedure [dbo].aju_planeaOTDesdeVisita
	@p_idOT int
as
BEGIN

if not exists(select 1 from doc_itemdocumento where id_documento=@p_idOT)
begin

	declare @idItemTemp int
	declare @idTemp int
	declare @idCategoria int
	declare @tipo int
	declare @uid varchar(50)

	select @uid=uid from seg_usuario where id=1

	set @idTemp=0

	select @idTemp=VIS.[id_catalogo.tempario]
	from [cat_catalogo.tempario] TEM
	inner join cat_detalleTempario DET on DET.[id_catalogo.tempario]=TEM.id
	inner join cnt_visitafija VIS on VIS.[id_catalogo.tempario]=TEM.id
	inner join [doc_documento.ot] OT on OT.id=VIS.[id_documento.ot]
	where OT.id=@p_idOT

	if @idTEmp>0
	begin
		
		--encabezado
		insert into doc_itemdocumento
		(uid,eid,itemdocumento,cantidadPlaneado,id_documento)
		select @uid,''01'',TEM.[catalogo.tempario],1,@p_idOT
		from [cat_catalogo.tempario] TEM
		inner join cnt_visitafija VIS on VIS.[id_catalogo.tempario]=TEM.id
		inner join [doc_documento.ot] OT on OT.id=VIS.[id_documento.ot]
		where OT.id=@p_idOT

		set @idItemTemp=@@identity
		set @tipo=1

		while @tipo<7
		begin

		if exists(	select 1 
					from [cat_catalogo.tempario] TEM
					inner join cat_detalleTempario DET on DET.[id_catalogo.tempario]=TEM.id
					inner join cnt_visitafija VIS on VIS.[id_catalogo.tempario]=TEM.id
					inner join [doc_documento.ot] OT on OT.id=VIS.[id_documento.ot]
					inner join cat_catalogo CAT on CAT.id=DET.id_catalogo
					inner join cat_subtipocatalogo SUB on SUB.id=CAT.id_subtipoCatalogo
					where OT.id=@p_idOT and SUB.id_tipoCatalogo=@tipo)
			begin

				insert into doc_itemdocumento
				(uid,eid,itemdocumento,id_itemDocumento_superior,id_documento)
				select @uid,''01'',tipocatalogo,@idItemTemp,@p_idOT
				from cat_tipocatalogo
				where id=@tipo

				set @idCategoria = @@identity

				insert into doc_itemdocumento
				(uid,eid,itemdocumento,cantidadPlaneado,id_itemDocumento_superior,id_documento,id_catalogo)
				select @uid,''01'',CAT.catalogo,DET.cantidadtropicalizada,@idCategoria,@p_idOT,CAT.id
				from cat_detalleTempario DET
				inner join [cat_catalogo.tempario] TEM on DET.[id_catalogo.tempario]=TEM.id
				inner join cnt_visitafija VIS on VIS.[id_catalogo.tempario]=TEM.id
				inner join [doc_documento.ot] OT on OT.id=VIS.[id_documento.ot]
				inner join cat_catalogo CAT on CAT.id=DET.id_catalogo
				inner join cat_subtipocatalogo SUB on SUB.id=CAT.id_subtipoCatalogo
				where OT.id=@p_idOT and SUB.id_tipoCatalogo=@tipo
			end
			set @tipo=@tipo+1
		end
	end
end

END
')
